package com.sa.ibiz.demo.demo.service.dto;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.ibizutil.domain.ParentData;
import com.sa.ibiz.demo.demo.domain.WXEntApp;
import org.springframework.util.StringUtils;
import lombok.Data;
import java.util.Map;
import java.sql.Timestamp;
import com.sa.ibiz.demo.ibizutil.service.SearchFilterBase;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.sa.ibiz.demo.ibizutil.helper.DataGridCustomSearchHelper;
import com.alibaba.fastjson.JSONObject;
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class WXEntAppSearchFilter extends SearchFilterBase {

	private String query;
	private Page page;
	private QueryWrapper<WXEntApp> selectCond;
	private JSONObject customsearchval;
	public WXEntAppSearchFilter(){
		this.page =new Page<WXEntApp>(1,Short.MAX_VALUE);
		this.selectCond=new QueryWrapper<WXEntApp>();	
	}

	/**
	 * 设定自定义查询条件，在原有SQL基础上追加该SQL
	 */
	public void setCustomCond(String sql)
	{
		this.selectCond.apply(sql);
	}

	private String n_apptype_eq;

	public void setN_apptype_eq(String n_apptype_eq) {
        this.n_apptype_eq = n_apptype_eq;
        if(!StringUtils.isEmpty(this.n_apptype_eq)){
            this.selectCond.eq("apptype", n_apptype_eq);
        }
    }
	private String n_wxaccountid_eq;

	public void setN_wxaccountid_eq(String n_wxaccountid_eq) {
        this.n_wxaccountid_eq = n_wxaccountid_eq;
        if(!StringUtils.isEmpty(this.n_wxaccountid_eq)){
            this.selectCond.eq("wxaccountid", n_wxaccountid_eq);
        }
    }
	private String n_wxaccountname_eq;

	public void setN_wxaccountname_eq(String n_wxaccountname_eq) {
        this.n_wxaccountname_eq = n_wxaccountname_eq;
        if(!StringUtils.isEmpty(this.n_wxaccountname_eq)){
            this.selectCond.eq("wxaccountname", n_wxaccountname_eq);
        }
    }
	private String n_wxaccountname_like;

	public void setN_wxaccountname_like(String n_wxaccountname_like) {
        this.n_wxaccountname_like = n_wxaccountname_like;
        if(!StringUtils.isEmpty(this.n_wxaccountname_like)){
            this.selectCond.like("wxaccountname", n_wxaccountname_like);
        }
    }
	private String n_wxentappname_like;

	public void setN_wxentappname_like(String n_wxentappname_like) {
        this.n_wxentappname_like = n_wxentappname_like;
        if(!StringUtils.isEmpty(this.n_wxentappname_like)){
            this.selectCond.like("wxentappname", n_wxentappname_like);
        }
    }

	public void setSrfparentdata(Map<String, String> srfparentdata) {
		this.srfparentdata = srfparentdata;
		String strParentkey=this.getSrfparentdata().get("srfparentkey");
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_WXENTAPP_WXACCOUNT_WXACCOUNTID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_wxaccountid_eq("NA");
			}
			else{
				this.setN_wxaccountid_eq(strParentkey);
			}
	}

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
			this.selectCond.or().like("wxentappname",query);
		 }
	}

	/**
	 * 自定义查询
	 * @param customsearchval
	 */
	public void setCustomsearchval(JSONObject customsearchval) {
		this.customsearchval = customsearchval;
		if(!StringUtils.isEmpty(customsearchval)){
			DataGridCustomSearchHelper customSearchHelper= DataGridCustomSearchHelper.getInstance();
			String customSql =customSearchHelper.parseCustomVal(customsearchval);
			this.selectCond.apply(customSql);
		}
	}

}